;;;       ,   ,   ,
;;;   ,  .      -  
;;;     .
;;;         ,  ()  .
;;;    .     Esc.
;;;   ,  :      
;;; ( ),   ( : "     :[Enter]"
;;;   ,     ,      .
;;;           .
;;;           . 
;;;       .
;;;   .        :
;;; %%c<>  <>%%d  -    (r<>, min<>...),         
;;;     .
;;; .            %%<>,       
;;;   ,   , %%<>
;;; .     ,     ,  .
;;;     ,      , ,   .
;;; 
;;;	 Prepared by : Okonechnikov A.N.                                      
;;;      	                                                              
;;;             	   Moscow                                       
;;;              	   Russia                                               
;;;---------------------------------------------------------------------------
;;;  Last revision : 21/11/2002.         "" .

(defun c:dim-txt (/	 osm	scmde  bli    eb     ebb    en
		  et	 flag	txt    copy   x	     last_txt
		  mesu
		 )
  (sssetfirst)
  (vla-StartUndoMark
    (vla-get-ActiveDocument (vlax-get-acad-object))
  )
  (setq osm (getvar "OSMODE"))
  (setq scmde (getvar "CMDECHO"))
  (setq bli (getvar "BLIPMODE"))
  (setvar "CMDECHO" 0)
  (setvar "OSMODE" 0)
  (setvar "BLIPMODE" 0)
  (SETQ old_error *error*)
  (while (not et)
    (dim-txt-dim)
  )
  (setvar "BLIPMODE" bli)
  (setvar "CMDECHO" scmde)
  (setvar "OSMODE" osm)

  (princ)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun dim-txt-dim (/)
  (setq en nil)
  (while (not en)
    (setvar "errno" 0)
    (while (or (equal 7 (getvar "errno")) (not (equal en 0)))
      (initget 0)
      (if flag
	(progn
	  (if (eq (cdr (assoc 0 (entget ebb))) "DIMENSION")
	    (setq copy "     ")
	    (setq copy "")
	  )
	)
	(progn
	  (setq copy "")
	  (if (or flag ebb)
	    (progn
	      (initget "U u Undo    ")
	      (setq x
		     (getkword
		       "\n[Enter]    [Undo/]: "
		     )
	      )
	      (if (or (eq x "U")
		      (eq x "u")
		      (eq x "Undo")
		      (eq x "")
		      (eq x "")
		      (eq x "")
		  )
		(progn
		  (if last_txt
		    (progn
		      (setq txt (car last_txt))
		      (setq last_txt (cdr last_txt))
		      (get-entmod)
		    )
		    (Princ "\n  ")
		  )
		)
	      )
	    )
	  )
	)
      )
      (setq eb (entsel
		 (strcat
		   "\n   "
		   copy
		   "  :[Enter] "
		 )
	       )
      )
      (if (equal 7 (getvar "errno"))
	(progn
	  (princ "\n  .")
	  (setvar "errno" 0)
	)
	(progn
	  (if (eq (getvar "errno") 52)
	    (progn
	      (setq en 0
		    et 0
	      )
	      (if ebb
		(redraw ebb 4)
	      )
	      (prompt "\n   ")
	      (princ)
	    )
	    (progn
	      (if
		(or
		  (eq (cdr (assoc 0 (entget (car eb)))) "DIMENSION")
		  (eq (cdr (assoc 0 (entget (car eb)))) "TEXT")
		  (eq (cdr (assoc 0 (entget (car eb)))) "MTEXT")
		  (eq
		    (cdr
		      (assoc 0 (entget (car (nentselp (car (cdr eb))))))
		    )
		    "ATTRIB"
		  )
		)
		 (progn
		   (setvar "errno" 0)
		   (setq en 0)
		   (get_txt)
		 )
		 (progn
		   (princ "\n ")
		 )
	      )
	    )
	  )
	)
      )
    )
  )
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun get_txt (/ obj block)
  (if (not flag)
    (progn
      (setq flag 0)
      (if (eq (cdr (assoc 0 (entget (car (nentselp (car (cdr eb)))))))
	      "ATTRIB"
	  )
	(redraw (setq ebb (car (nentselp (car (cdr eb))))) 3)
	(redraw (setq ebb (car eb)) 3)
      )
      (if (eq (cdr (assoc 0 (entget ebb))) "DIMENSION")
	(progn
	  (if (eq (cdr (assoc 1 (entget ebb))) "")
	    (progn
	      (setq block
		     (tblobjname "BLOCK" (cdr (assoc 2 (entget ebb))))
	      )
	      (while block
		(setq Obj block)
		(if (eq (cdr (assoc 0 (entget obj))) "MTEXT")
		  (progn
		    (setq mesu (cdr (assoc 1 (entget obj))))
		    (if	(numberp (vl-string-position 59 mesu 0 t))
		      (setq
			mesu (substr
			       mesu
			       (+ (vl-string-position 59 mesu 0 t) 2)
			     )
		      )
		    )
		  )
		)
		(setq block (entnext block))
	      )
	    )
	    (setq mesu (cdr (assoc 1 (entget ebb))))
	  )
	)
	(progn
	  (if
	    (eq	(cdr (assoc 0 (entget ebb)))
		"ATTRIB"
	    )

	     (setq mesu
		    (cdr (assoc 1 (entget ebb))
		    )
	     )

	     (setq mesu (cdr (assoc 1 (entget ebb))))
	  )
	)

      )
      (dim-txt-dim)
    )
    (progn

      (redraw ebb 4)
      (setvar "errno" 0)
      (setq en 0)
      (if (and (not (eq (cdr (assoc 0 (entget (car eb)))) "DIMENSION"))
	       (eq (cdr (assoc 0 (entget ebb))) "DIMENSION")
	  )
	(progn
	  (if (and (numberp (vl-string-search "<>" mesu))
		   (not (eq (cdr (assoc 42 (entget ebb))) -1))
	      )
	    (setq
	      mesu
	       (strcat (vl-string-trim "<>" mesu)
		       (rtos (cdr (assoc 42 (entget ebb)))
			     2
			     (cdr
			       (assoc
				 271
				 (entget
				   (tblobjname
				     "DIMSTYLE"
				     (cdr (assoc 3 (entget ebb)))
				   )
				 )
			       )
			     )
		       )
	       )
	    )
	  )
	)
      )
      (if (eq (cdr (assoc 0 (entget (car (nentselp (car (cdr eb)))))))
	      "ATTRIB"
	  )
	(setq txt (entget (car (nentselp (car (cdr eb))))))
	(setq txt (entget (car eb)))
      )


      (setq last_txt (append (list txt) last_txt))
      (if
	(and
	  (eq ebb (car eb))
	  (eq (cdr (assoc 0 txt)) "DIMENSION")
	)
	 (progn

	   (setq txt (subst (cons 1 (chr 0)) (cons 1 mesu) txt))
	 )
	 (setq txt (subst (cons 1 mesu) (assoc 1 txt) txt))
      )
      (get-entmod)
      (Princ)
      (setq flag nil
	    mesu nil
	    txt	 nil
      )
      (dim-txt-dim)
    )
  )
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun get-entmod (/)

  (if (eq (cdr (assoc 0 txt))
	  "ATTRIB"
      )
    (progn
      (entmod txt)
      (entupd (cdar txt))
      (entupd (car eb))
      (redraw)
    )
    (entmod txt)
  )
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun *error* (msg)
  (if old_error
    (progn (setq *error* old_error)
	   (vla-EndUndoMark
	     (vla-get-ActiveDocument (vlax-get-acad-object))
	   )
	   (command "_U")
    )
  )
  (if msg
    (progn (princ
	     "\n:    . *Cancel*"
	   )
	   (princ "\n")
    )
  )
  (setvar "CMDECHO" scmde)
  (setvar "OSMODE" osm)
  (setvar "BLIPMODE" bli)
  (if ebb
    (redraw ebb 4)
  )
  (GC)
)

