;;;     , , , 
;;;   .     Esc.
;;;
;;;	 Prepared by : Okonechnikov A.N.                                      
;;;      	                                                              
;;;             	   Moscow                                       
;;;              	   Russia                                               
;;;---------------------------------------------------------------------------
;;;  Last revision : 16/11/2002.   

(defun c:get_text (/ osm sblib scmde x et eb en txt last_txt)
  (sssetfirst)
  (vla-StartUndoMark
    (vla-get-ActiveDocument (vlax-get-acad-object))
  )
  (setq osm (getvar "OSMODE"))
  (setq sblip (getvar "BLIPMODE"))
  (setq scmde (getvar "CMDECHO"))
  (setvar "BLIPMODE" 0)
  (setvar "CMDECHO" 0)
  (setvar "OSMODE" 0)
  (SETQ old_error *error*)
  (while (not et)
    (ftext)
  )
  (setvar "BLIPMODE" sblip)
  (setvar "CMDECHO" scmde)
  (setvar "OSMODE" osm)
  (setq	eb nil
	txt nil
	last_txt nil
  )
  (princ)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun ftext (/)
  (setq en nil)
  (while (not en)
    (setvar "errno" 0)
    (while (or (equal 7 (getvar "errno")) (not (equal en 0)))
      (if last_txt
	(progn
	  (initget "U u Undo    ")
	  (setq	x
		 (getkword
		   "\n [Enter]    [Undo/]: "
		 )
	  )
	  (if (or (eq x "U")
		  (eq x "u")
		  (eq x "Undo")
		  (eq x "")
		  (eq x "")
		  (eq x "")
	      )
	    (progn
	      (if last_txt
		(progn
		  (setq txt (car last_txt))
		  (setq last_txt (cdr last_txt))
		  (get-entmod)
		)
		(Princ "\n  ")
	      )
	    )
	  )
	)
      )
      (setq x
	     (getstring	T
			"\n  (Enter -  ): "

	     )
      )

      (setq eb (entsel
		 (strcat
		   "\n      [Enter]"
		 )
	       )
      )

      (if (equal 7 (getvar "errno"))
	(progn
	  (princ "\n  .")
	  (setvar "errno" 0)
	)
	(progn
	  (if (eq (getvar "errno") 52)
	    (progn
	      (setq en 0
		    et 0
	      )

	      (prompt "\n   ")
	      (princ)
	    )
	    (progn
	      (if
		(or
		  (eq (cdr (assoc 0 (entget (car eb)))) "DIMENSION")
		  (eq (cdr (assoc 0 (entget (car eb)))) "TEXT")
		  (eq (cdr (assoc 0 (entget (car eb)))) "MTEXT")
		  (eq
		    (cdr
		      (assoc 0 (entget (car (nentselp (car (cdr eb))))))
		    )
		    "ATTRIB"
		  )
		)
		 (progn
		   (setvar "errno" 0)
		   (setq en 0)
		   (get_ftext)
		 )
		 (progn
		   (princ "\n ")
		 )
	      )
	    )
	  )
	)
      )
    )
  )
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun get_ftext (/)

					;(setq flag nil)

  (setvar "errno" 0)
  (setq en 0)
  (if (eq (cdr (assoc 0 (entget (car (nentselp (car (cdr eb)))))))
	  "ATTRIB"
      )
    (setq txt (entget (car (nentselp (car (cdr eb))))))
    (setq txt (entget (car eb)))
  )
  (setq last_txt (append (list txt) last_txt))

  (setq txt (subst (cons 1 x) (assoc 1 txt) txt))

  (get-entmod)
  (Princ)
  (ftext)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun get-entmod (/)

  (if (eq (cdr (assoc 0 txt))
	  "ATTRIB"
      )
    (progn
      (entmod txt)
      (entupd (cdar txt))
      (entupd (car eb))
      (redraw)
    )
    (entmod txt)
  )
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun *error* (msg)
  (if old_error
    (progn (setq *error* old_error)
	   (vla-EndUndoMark
	     (vla-get-ActiveDocument (vlax-get-acad-object))
	   )
	   (command "_U")
    )
  )
  (if msg
    (progn (princ
	     "\n:    . *Cancel*"
	   )
	   (princ "\n")
    )
  )
  (setvar "BLIPMODE" sblip)
  (setvar "CMDECHO" scmde)
  (setvar "OSMODE" osm)
  (GC)
)
